#define _CRT_SECURE_NO_WARNINGS

#ifndef HUI
#pragma GCC optimize("O3")
#endif // !HUI

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <numeric>
#include <random>
#include <ctime>
#include <cassert>

typedef long long ll;
typedef long double ld;
long long inf = 1'000'000'007;
long long linf = 1'000'000'000'000'000'007LL;

using namespace std;

/*
void solve() {
	int n, a, b;
	cin >> n >> a >> b;
	map <int, vector <int>> by_dec;
	for (int _ = 0; _ < n; _++) {
		int dec, num;
		cin >> dec >> num;
		by_dec[dec].push_back(num);
	}
	// {insert, delete}
	vector <pair<int, int>> alternatives = { {0, 0} };

	for (auto dec : by_dec) {

		auto arr = dec.second;
		sort(arr.begin(), arr.end());

		vector <pair <int, int>> my_alts = { };

		int prefix_ok = 0;
		int next_to_give = 1;
		for (int to_insert = 0; to_insert < 2 * arr.size() + 2; to_insert++) {
			while (prefix_ok < arr.size() && arr[prefix_ok] == next_to_give) {
				next_to_give++;
				prefix_ok++;
			}
			// when inserted, next_to_give is on prefix, should verify from prefix_ok ndx

			int ans = 0;

			int real_1_ndxed = next_to_give;
			for (int i = prefix_ok; i < arr.size(); i++) {
				if (arr[i] > real_1_ndxed * 2 - 1) {
					ans++;
				}
				else {
					real_1_ndxed++;
				}
			}
			my_alts.push_back({ to_insert, ans });

			next_to_give++;
		}

		map<int, int> best_option;

		for (auto i : alternatives) {
			for (auto j : my_alts) {
				int new_insert = i.first + j.first;
				int new_kill = i.second + j.second;

				if (!best_option.count(new_insert)) {
					best_option[new_insert] = inf;
				}
				best_option[new_insert] = min(new_kill, best_option[new_insert]);
			}
		}

		alternatives.clear();
		int prev_kill = inf;
		for (auto i : best_option) {
			if (i.first > n + 1)
				break;
			alternatives.push_back({ i.first, min(i.second, prev_kill) });
			prev_kill = min(prev_kill, i.second);
		}
	}
	int ans = inf;
	for (auto i : alternatives) {
		ans = min(ans, max(i.first, i.second));
	}
	cout << ans << endl;
}
*/


template<int Modulo>
struct MOD {
	static const int M = Modulo;
	unsigned int x;
	MOD(int val = 0) : x(val) { assert(0 <= val && val < M); }

	MOD& operator +=(MOD r) {
		x += r.x;
		if (x >= M)
			x -= M;
		return *this;
	}
	friend MOD operator+(MOD l, MOD r) { return l += r; }

	MOD& operator *=(MOD r) {
		x = (ll(x) * r.x) % M;
		return *this;
	}
	friend MOD operator*(MOD l, MOD r) { return l *= r; }

	MOD& operator -=(MOD r) {
		x -= r.x;
		if (x >= M)
			x += M;
		return *this;
	}
	friend MOD operator-(MOD l, MOD r) { return l -= r; }

	friend MOD operator -(MOD a) {
		if (a.x)
			return M - a.x;
		return 0;
	}

	friend ostream& operator <<(ostream& cout, MOD x) { return cout << x.x; }
	friend bool operator ==(MOD l, MOD r) { return l.x == r.x; }
	friend bool operator <(MOD l, MOD r) { return l.x < r.x; }
};

namespace std {
	template<int Modulo>
	struct hash<MOD<Modulo>> {
		size_t operator()(MOD<Modulo> a) const noexcept { return a.x; }
	};
}

template<int M>
MOD<M> binpow(MOD<M> a, ll p)
{
	MOD<M> res = 1;
	while (p) {
		if (p & 1)
			res *= a;
		a *= a;
		p >>= 1;
	}
	return res;
}

using Mod = MOD<1'000'000'007>;

Mod inv(Mod x)
{
	assert(x.x != 0);
	return binpow(x, 1'000'000'007 - 2);
}

long long maybe_get(Mod target, vector<Mod>&init) {

	vector <Mod> deltas(init.size());
	for (int i = 0; i < init.size(); i++) {
		deltas[i] = init[i] - target;
	}
		 
	Mod total = deltas[0];
	Mod multiplicator = inf-2;


	for (int i = deltas.size() - 1; i > 0; i--) {
		total += deltas[i] * multiplicator;

		multiplicator *= inf-2;
	}

	Mod koef = 1 - multiplicator;
	vector <long long> ks(init.size());

	ks[0] = (total * inv(koef)).x;

	for (int i = 1; i < init.size();i++) {
		ks[i] = (ll)deltas[i].x - 2LL * ks[i - 1];
		if (ks[i] < 0)
			return -1;
	}

	long long mnk = (*min_element(ks.begin(), ks.end()));
	for (int i = 0; i < ks.size(); i++)
		ks[i] -= mnk;

	long long exp = target.x + 3 * mnk;

	for (int i = 0; i < init.size();i++) {
		int prev = i - 1;
		if (prev == -1)
			prev = init.size() - 1;

		if (exp != init[i].x - 2 * ks[prev] - ks[i])
			return -1;
	}

	return exp;
}

void solve() {
	int n;
	cin >> n;

	vector<Mod> v(n);
	for (int i = 0;i < n;i++) {
		int x;
		cin >> x;
		v[i] = Mod(x);
	}

	int ans = 0;

	for (int j = 0; j < 3; j++) {
		int res = maybe_get(Mod(j), v);
		if (res != -1)
			ans = max(ans, res);
	}

	cout << ans << endl;
}

int main() {
#ifdef HUI
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(false);
	cout.sync_with_stdio(false);
	srand(time(0));
	cout.precision(10);

	int tt = 1;
	cin >> tt;
	while (tt--)
		solve();
}