#include <iostream>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <sstream>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <tuple>
#include <random>
#include <chrono>

using namespace std;

#define ln "\n"
#define pb push_back
#define mp make_pair
#define ins insert
#define sz(x) (int)x.size()
#define All(x) (x).begin(), (x).end()
#define Allf(x) (x).begin() + 1, (x).end()

#define fi(a, b) for(auto i = a; i <= b; i++)
#define fj(a, b) for(auto j = a; j <= b; j++)
#define fo(a, b) for(auto o = a; o <= b; o++)
#define fw(a, b) for(auto w = a; w <= b; w++)

#define fdi(a, b) for(auto i = a; i >= b; i--)
#define fdj(a, b) for(auto j = a; j >= b; j--)
#define fdo(a, b) for(auto o = a; o >= b; o--)
#define fdw(a, b) for(auto w = a; w >= b; w--)

#define fx( A) for(auto& x: (A) )
#define fy( A) for(auto& y: (A) )
#define fz( A) for(auto& z: (A) )

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<long long> vll;
typedef vector<vi> vvi;
typedef pair<int, int> pii;

template<typename T>
ostream& operator<<(ostream& os, vector<T> v){
    fx( v) {
        os << x << ' ';
    }
    return os;
}

template<typename T>
ostream& operator<<(ostream& os, set<T> v){
    fx( v) {
        os << x << ' ';
    }
    return os;
}

template<typename T1,typename T2>
ostream& operator<<(ostream& os, pair<T1,T2> v){
    
    os << "(" << v.first << ", " << v.second << ")";
    
    return os;
}

#ifdef LOCAL
#define dbg(x) { cerr << __LINE__ << "\t" << #x << ": " <<  (x) << ln; }
#else
#define dbg(x) {}
#endif

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int MAX = 100'000;
const int mod = 998'244'353;

int add(int a, int b) {
    return (a + b) % mod;
}
int sub(int a, int b) {
    return ((a - b) % mod + mod) % mod;
}
int mult(int a, int b) {
    return (ll)a * b % mod;
}


int n;
vector<deque<pii>> a;
vector<int> ax;
vector<deque<pii>> b;
vector<int> bx;
vector<int> pref;

int can_move_single(pii x, pii y) {
    if (x.first == -MAX) return 0;
    if (y.first == -MAX) return 0;
    if (x.first != x.second) return 0;
    if (y.first != y.second) return 0;
    if (x.first != y.first - 1) return 0;
    return 1;
}
int can_move(pii x, pii y) {
    if (x.first == -MAX) return 0;
    if (y.first == -MAX) return 0;
    if (x.second == y.first - 1) return 1;
    return 0;
}

void move_top(int x, int y, vector<deque<pii>>& a) {
    auto t1 = a[x].front();
    auto t2 = a[y].front();
    a[x].pop_front();
    a[y].pop_front();
    a[y].push_front({t1.first, t2.second});
}   

int premove(vector<deque<pii>>& a) {
    int res = 0;
    while(sz(a[1]) + sz(a[2]) + sz(a[3]) != 1) {
        auto t1 = (sz(a[1]) ? a[1].front() : mp(-MAX, -MAX));
        auto t2 = (sz(a[2]) ? a[2].front() : mp(-MAX, -MAX));
        auto t3 = (sz(a[3]) ? a[3].front() : mp(-MAX, -MAX));
        if (can_move_single(t1, t2) && t1.first > t3.first) {
            move_top(1, 2, a);
            res = add(res, 1);
        } else if(can_move_single(t2, t1) && t2.first > t3.first) {
            move_top(2, 1, a);
            res = add(res, 1);
        } else if(can_move_single(t2, t3) && t2.first > t1.first) {
            move_top(2, 3, a);
            res = add(res, 1);
        } else if(can_move_single(t3, t2) && t3.first > t1.first) {
            move_top(3, 2, a);
            res = add(res, 1);
        } else if(can_move(t1, t2)) {
            move_top(1, 2, a);
            res = add(res, mult(pref[t1.second], 1));
        } else if (can_move(t1, t3)) {
            move_top(1, 3, a);
            res = add(res, mult(pref[t1.second], 2));
        } else if (can_move(t2, t3)) {
            move_top(2, 3, a);
            res = add(res, mult(pref[t2.second], 1));
        } else if (can_move(t3, t2)) {
            move_top(3, 2, a);
            res = add(res, mult(pref[t3.second], 1));
        } else if (can_move(t3, t1)) {
            move_top(3, 1, a);
            res = add(res, mult(pref[t3.second], 2));
        }
    }
    return res;
}

void solve() {
    dbg(0);
    int premove_a = premove(a);
    dbg(1);
    int premove_b = premove(b);
    dbg(2);
    dbg(mp(premove_a, premove_b));

    int build = mult(pref[n], abs(ax[n] - bx[n]));
    dbg(build);
    int ans = sub(build, add(premove_a, premove_b));
    cout << ans << ln;
}

void init() {
    pref = vi(MAX + 1);
    pref[1] = 1;
    fi(2, MAX) {
        pref[i] = add(mult(pref[i - 1], 3), 1);
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #endif

    init();
    int TEST;
    cin >> TEST;
    while(TEST--) {
        dbg("__________________");
        cin >> n;
        a = vector<deque<pii>>(4);
        ax = vector<int>(n + 1);
        b = vector<deque<pii>>(4);
        bx = vector<int>(n + 1);
        fi(1, n) {
            int x;
            cin >> x;
            ax[i] = x;
            if (sz(a[x]) && a[x].back().second == i - 1) {
                auto prev = a[x].back();
                a[x].pop_back();
                a[x].pb({prev.first, i});
            } else {
                a[x].pb({i, i});
            }
        }
        fi(1, n) {
            int x;
            cin >> x;
            bx[i] = x;
            if (sz(b[x]) && b[x].back().second == i - 1) {
                auto prev = b[x].back();
                b[x].pop_back();
                b[x].pb({prev.first, i});
            } else {
                b[x].pb({i, i});
            }
        }
        if (ax == bx) {
            cout << 0 << ln;
            continue;
        }
        solve();
    }

    return 0;

}