#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstdint>

template<class T>
std::vector<T> ReadArray(size_t size) {
	std::vector<T> result(size);
	for (size_t i = 0; i != size; ++i) {
		std::cin >> result[i];
	}

	return result;
}

struct Mountain {
	long long old, current;

	long long GetDiff() {
		return old - current;
	}
};

long long Solve(size_t n, std::vector<Mountain>& mountains) {
	std::sort(mountains.begin(), mountains.end(), [](Mountain& first, Mountain& second) { 
		return first.old < second.old; });
	for (size_t i = 0; i != n - 1; ++i) {
		if (mountains[i].current > mountains[i + 1].current) {
			return -1;
		}
	}
	long long accum = 0;
	for (size_t i = 0; i != n; ++i) {
		auto diff = mountains[i].GetDiff();
		if (diff < accum) {
			return -1;
		}
		diff -= accum;
		accum += diff;
	}

	return accum;
}

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	size_t t;
	std::cin >> t;
	std::vector<long long> result;
	for (size_t _ = 0; _ != t; _++) {
		size_t n;
		std::cin >> n;
		std::vector<Mountain> mountains(n);
		for (size_t i = 0; i != n; ++i) {
			std::cin >> mountains[i].current;
		}
		for (size_t i = 0; i != n; ++i) {
			std::cin >> mountains[i].old;
		}
		result.push_back(Solve(n, mountains));
	}

	for (auto a : result) {
		std::cout << a << "\n";
	}
}
