﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include<string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <numeric>
#include <algorithm>
#include <queue>
#include <stack>
#include <deque>
#include <utility>
#include <tuple>
#include <list>
#include <random>
#include <ctime>


#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using ll = long long;
using ld = long double;

using namespace std;

vector<vector<int>> from, in;
vector<int> seen;
vector<int> topsort;


void dfs(int v) {
    seen[v] = 1;

    for (auto& to : from[v]) {
        if (seen[to]) continue;

        dfs(to);
    }

    topsort.push_back(v);
}

struct vertex {
    int from;
    int in;
    int v;

    vertex() {};

    vertex(int a, int b, int c) {
        from = a;
        in = b;
        v = c;
    }
};

bool comp(vertex a, vertex b) {
    int g = a.from * b.in - a.in * b.from;
    if (g == 0) return a.from > b.from;
    
    return g > 0;
}


void solve() {
    int n, m;

    cin >> n >> m;

    vector<pair<int, int>> edges(m);
    vector<vertex> ver;

    from.assign(n, vector<int>());
    in.assign(n, vector<int>());
    seen.assign(n, 0);
    topsort.clear();
    ver.resize(n);

    for (int i = 0; i < m; ++i) {
        int x, y;

        cin >> x >> y;

        --x; --y;

        edges[i] = { x, y };

        in[y].push_back(x);
        from[x].push_back(y);

    }

    for (int i = 0; i < n; i++) {
        ver[i] = vertex(from[i].size(), in[i].size(), i);
    }

    shuffle(ver.begin(), ver.end(), mt19937(time(NULL)));

    /*for (int i = 0; i < n; ++i) {
        shuffle(all(from[i]), mt19937(time(NULL)));
    }*/

    //vector<tuple<int, int, int>> order;

    /*for (int i = 0; i < n; ++i) {
        order.push_back({ -from[i].size(), in[i].size(), i });
    }*/

    sort(all(ver), &comp);

    for (int i = 0; i < n; ++i) {
        if (!seen[ver[i].v]) dfs(ver[i].v);
    }

    reverse(all(topsort));

    vector<int> time(n);

    for (int i = 0; i < n; ++i) {
        time[topsort[i]] = i;
    }

    int cnt = 0;

    for (int i = 0; i < m; ++i) {
        if (time[edges[i].first] < time[edges[i].second]) {
            ++cnt;
        }
    }

    if (cnt >= (m - 1) / 2 + 1) {
        for (int i = 0; i < n; ++i) {
            cout << topsort[i] + 1 << ' ';
        }

        cout << endl;
    }
    else {
        cout << -1 << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;

    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}
