#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <unordered_map>
#include <unordered_set>

using namespace std;

int n, e;
unordered_set<char> impossible, not_interested, possible;

char find_char(vector<string>& arr, vector<int>& states) {
    vector<bool> flags(e);
    for (int i = 0; i < states.size(); ++i)
        flags[arr[i][states[i]] - 'a'] = true;


    for (int i = 0; i < e; ++i)
        if (!flags[i]) return 'a' + i;

    return '#';
}

int main() {
    cin >> n >> e;

    for(char a = 'a'; a <= ('a' + e - 1); a++)
        impossible.insert(a);

    vector<string> arr;
    arr.reserve(n);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        char c = s[0];
        bool flag = true;
        for (int j = 0; j < s.size(); ++j) {
            if (s[j] != c) flag = false;
            impossible.erase(s[j]);
        }
        if (flag) {
            not_interested.insert(c);
        } else {
            arr.push_back(s);
        }
    }

    for(char a = 'a'; a <= ('a' + e - 1); a++)
        if (!impossible.count(a))
            possible.insert(a);

    if (!impossible.empty()) {
        cout << *impossible.begin();
    } else if (not_interested.size() == e) {
        cout << "NO";
    } else {
        vector<int> states(arr.size());
        deque<pair<string, vector<int>>> q;

        q.emplace_back("", states);
        string answer = "-";

        while (answer == "-") {
            auto [s, state] = q.front();

            q.pop_front();
            char p = find_char(arr, state);
            if (p != '#') {
                answer = s + p;
                break;
            }

            for (int i = 0; i < arr.size(); ++i) {
                state[i] = (state[i] + 1) % arr.size();
                q.emplace_back(s + arr[i][(state[i] + arr.size() - 1) % arr.size()], state);
                state[i] = (state[i] + arr.size() - 1) % arr.size();
            }
        }
        cout << answer << '\n';
    }
}